def distSqr(p1,p2):
	return (p1[0]-p2[0])**2 + (p1[1]-p2[1])**2
	
def segToRect(segment,rect):
	#left
	if segToSeg(segment,((rect[0],rect[1]),(rect[0],rect[1]+rect[3]))):
		return True
	#top
	if segToSeg(segment,((rect[0],rect[1]),(rect[0]+rect[2],rect[1]))):
		return True
	#bottom
	if segToSeg(segment,((rect[0],rect[1]+rect[3]),(rect[0]+rect[2],rect[1]+rect[3]))):
		return True
	#right
	if segToSeg(segment,((rect[0]+rect[2],rect[1]),(rect[0]+rect[2],rect[1]+rect[3]))):
		return True
	return False


def segToSeg(s1,s2):
	x1 = float(s1[0][0])
	x2 = float(s1[1][0])
	x3 = float(s2[0][0])
	x4 = float(s2[1][0])
	y1 = float(s1[0][1])
	y2 = float(s1[1][1])
	y3 = float(s2[0][1])
	y4 = float(s2[1][1])
	
	denom = ( (y4-y3)*(x2-x1) - (x4-x3)*(y2-y1) )
	if not denom:
		return False
	ua = ( (x4-x3)*(y1-y3) - (y4-y3)*(x1-x3) ) / denom
	ub = ( (x2-x1)*(y1-y3) - (y2-y1)*(x1-x3) ) / denom
	
#	x = x1 + ua * (x2-x1)
#	y = y1 + ub * (y2-y1)
	if 0 < ua < 1 and 0 < ub < 1:
		return True
	return False