import pygame,os

class ImageManager:
	
	def __init__(self):
		self.imgs = {}
		self.here = os.path.abspath(os.path.dirname(__file__))
	
	def get(self,img,copy=False):
		s = self.imgs.get(img)
		if not s:
			try:
				path = os.path.join(self.here,"..","data","i",img)
				s = pygame.image.load(path)
			except:
				print "ERR: Couldn't load %s" % path
				s = pygame.Surface((20,20))
				s.fill(0xff0000)
			self.imgs[img] = s
		if copy:
			return s.copy()
		return s

im = ImageManager()