import pygame,os

class SoundMan:
	
	def __init__(self):
		try:
			pygame.mixer.init()
			self.noSound = False
		except:
			self.noSound = True
		self.sounds = {}
		self.here = os.path.abspath(os.path.dirname(__file__))
	
	def play(self,snd):
		if self.noSound:
			return
		s = self.sounds.get(snd)
		if not s:
			path = os.path.join(self.here,"..","data","s",snd)
			s = pygame.mixer.Sound(path)
			self.sounds[snd] = s
		s.play()

sm = SoundMan()